"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NextScript = exports.Main = exports.Head = exports.default = void 0;

var _getPrototypeOf = _interopRequireDefault(require("@babel/runtime/core-js/object/get-prototype-of"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _htmlescape = _interopRequireDefault(require("htmlescape"));

var _server = _interopRequireDefault(require("styled-jsx/server"));

/* eslint-disable */
var Fragment = _react.default.Fragment || function Fragment(_ref) {
  var children = _ref.children;
  return _react.default.createElement("div", null, children);
};

var Document =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(Document, _Component);

  function Document() {
    (0, _classCallCheck2.default)(this, Document);
    return (0, _possibleConstructorReturn2.default)(this, (Document.__proto__ || (0, _getPrototypeOf.default)(Document)).apply(this, arguments));
  }

  (0, _createClass2.default)(Document, [{
    key: "getChildContext",
    value: function getChildContext() {
      return {
        _documentProps: this.props
      };
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement("html", null, _react.default.createElement(Head, null), _react.default.createElement("body", null, _react.default.createElement(Main, null), _react.default.createElement(NextScript, null)));
    }
  }], [{
    key: "getInitialProps",
    value: function getInitialProps(_ref2) {
      var renderPage = _ref2.renderPage;

      var _renderPage = renderPage(),
          html = _renderPage.html,
          head = _renderPage.head,
          errorHtml = _renderPage.errorHtml,
          buildManifest = _renderPage.buildManifest;

      var styles = (0, _server.default)();
      return {
        html: html,
        head: head,
        errorHtml: errorHtml,
        styles: styles,
        buildManifest: buildManifest
      };
    }
  }]);
  return Document;
}(_react.Component);

exports.default = Document;
Object.defineProperty(Document, "childContextTypes", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: {
    _documentProps: _propTypes.default.any
  }
});

var Head =
/*#__PURE__*/
function (_Component2) {
  (0, _inherits2.default)(Head, _Component2);

  function Head() {
    (0, _classCallCheck2.default)(this, Head);
    return (0, _possibleConstructorReturn2.default)(this, (Head.__proto__ || (0, _getPrototypeOf.default)(Head)).apply(this, arguments));
  }

  (0, _createClass2.default)(Head, [{
    key: "getPreloadMainLinks",
    value: function getPreloadMainLinks() {
      var _this = this;

      var _context$_documentPro = this.context._documentProps,
          assetPrefix = _context$_documentPro.assetPrefix,
          files = _context$_documentPro.files;

      if (!files || files.length === 0) {
        return null;
      }

      return files.map(function (file) {
        // Only render .js files here
        if (!/\.js$/.exec(file)) {
          return null;
        }

        return _react.default.createElement("link", {
          key: file,
          nonce: _this.props.nonce,
          rel: "preload",
          href: "".concat(assetPrefix, "/_next/").concat(file),
          as: "script"
        });
      });
    }
  }, {
    key: "getCssLinks",
    value: function getCssLinks() {
      var _this2 = this;

      var _context$_documentPro2 = this.context._documentProps,
          assetPrefix = _context$_documentPro2.assetPrefix,
          files = _context$_documentPro2.files;

      if (!files || files.length === 0) {
        return null;
      }

      return files.map(function (file) {
        // Only render .css files here
        if (!/\.css$/.exec(file)) {
          return null;
        }

        return _react.default.createElement("link", {
          key: file,
          nonce: _this2.props.nonce,
          rel: "stylesheet",
          href: "".concat(assetPrefix, "/_next/").concat(file)
        });
      });
    }
  }, {
    key: "getPreloadDynamicChunks",
    value: function getPreloadDynamicChunks() {
      var _this3 = this;

      var _context$_documentPro3 = this.context._documentProps,
          dynamicImports = _context$_documentPro3.dynamicImports,
          assetPrefix = _context$_documentPro3.assetPrefix;
      return dynamicImports.map(function (bundle) {
        return _react.default.createElement("script", {
          async: true,
          key: bundle.file,
          src: "".concat(assetPrefix, "/_next/").concat(bundle.file),
          as: "script",
          nonce: _this3.props.nonce
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _context$_documentPro4 = this.context._documentProps,
          head = _context$_documentPro4.head,
          styles = _context$_documentPro4.styles,
          assetPrefix = _context$_documentPro4.assetPrefix,
          __NEXT_DATA__ = _context$_documentPro4.__NEXT_DATA__;
      var page = __NEXT_DATA__.page,
          pathname = __NEXT_DATA__.pathname,
          buildId = __NEXT_DATA__.buildId;
      var pagePathname = getPagePathname(pathname);
      return _react.default.createElement("head", this.props, (head || []).map(function (h, i) {
        return _react.default.cloneElement(h, {
          key: h.key || i
        });
      }), page !== '/_error' && _react.default.createElement("link", {
        rel: "preload",
        href: "".concat(assetPrefix, "/_next/static/").concat(buildId, "/pages").concat(pagePathname),
        as: "script",
        nonce: this.props.nonce
      }), _react.default.createElement("link", {
        rel: "preload",
        href: "".concat(assetPrefix, "/_next/static/").concat(buildId, "/pages/_app.js"),
        as: "script",
        nonce: this.props.nonce
      }), _react.default.createElement("link", {
        rel: "preload",
        href: "".concat(assetPrefix, "/_next/static/").concat(buildId, "/pages/_error.js"),
        as: "script",
        nonce: this.props.nonce
      }), this.getPreloadDynamicChunks(), this.getPreloadMainLinks(), this.getCssLinks(), styles || null, this.props.children);
    }
  }]);
  return Head;
}(_react.Component);

exports.Head = Head;
Object.defineProperty(Head, "contextTypes", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: {
    _documentProps: _propTypes.default.any
  }
});
Object.defineProperty(Head, "propTypes", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: {
    nonce: _propTypes.default.string
  }
});

var Main =
/*#__PURE__*/
function (_Component3) {
  (0, _inherits2.default)(Main, _Component3);

  function Main() {
    (0, _classCallCheck2.default)(this, Main);
    return (0, _possibleConstructorReturn2.default)(this, (Main.__proto__ || (0, _getPrototypeOf.default)(Main)).apply(this, arguments));
  }

  (0, _createClass2.default)(Main, [{
    key: "render",
    value: function render() {
      var _context$_documentPro5 = this.context._documentProps,
          html = _context$_documentPro5.html,
          errorHtml = _context$_documentPro5.errorHtml;
      return _react.default.createElement(Fragment, null, _react.default.createElement("div", {
        id: "__next",
        dangerouslySetInnerHTML: {
          __html: html
        }
      }), _react.default.createElement("div", {
        id: "__next-error",
        dangerouslySetInnerHTML: {
          __html: errorHtml
        }
      }));
    }
  }]);
  return Main;
}(_react.Component);

exports.Main = Main;
Object.defineProperty(Main, "contextTypes", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: {
    _documentProps: _propTypes.default.any
  }
});

var NextScript =
/*#__PURE__*/
function (_Component4) {
  (0, _inherits2.default)(NextScript, _Component4);

  function NextScript() {
    (0, _classCallCheck2.default)(this, NextScript);
    return (0, _possibleConstructorReturn2.default)(this, (NextScript.__proto__ || (0, _getPrototypeOf.default)(NextScript)).apply(this, arguments));
  }

  (0, _createClass2.default)(NextScript, [{
    key: "getScripts",
    value: function getScripts() {
      var _this4 = this;

      var _context$_documentPro6 = this.context._documentProps,
          assetPrefix = _context$_documentPro6.assetPrefix,
          files = _context$_documentPro6.files;

      if (!files || files.length === 0) {
        return null;
      }

      return files.map(function (file) {
        // Only render .js files here
        if (!/\.js$/.exec(file)) {
          return null;
        }

        return _react.default.createElement("script", {
          key: file,
          src: "".concat(assetPrefix, "/_next/").concat(file),
          nonce: _this4.props.nonce,
          async: true
        });
      });
    }
  }, {
    key: "getDynamicChunks",
    value: function getDynamicChunks() {
      var _this5 = this;

      var _context$_documentPro7 = this.context._documentProps,
          dynamicImports = _context$_documentPro7.dynamicImports,
          assetPrefix = _context$_documentPro7.assetPrefix;
      return dynamicImports.map(function (bundle) {
        return _react.default.createElement("script", {
          async: true,
          key: bundle.file,
          src: "".concat(assetPrefix, "/_next/").concat(bundle.file),
          nonce: _this5.props.nonce
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _context$_documentPro8 = this.context._documentProps,
          staticMarkup = _context$_documentPro8.staticMarkup,
          assetPrefix = _context$_documentPro8.assetPrefix,
          __NEXT_DATA__ = _context$_documentPro8.__NEXT_DATA__;
      var page = __NEXT_DATA__.page,
          pathname = __NEXT_DATA__.pathname,
          buildId = __NEXT_DATA__.buildId;
      var pagePathname = getPagePathname(pathname);
      return _react.default.createElement(Fragment, null, staticMarkup ? null : _react.default.createElement("script", {
        nonce: this.props.nonce,
        dangerouslySetInnerHTML: {
          __html: "\n          __NEXT_DATA__ = ".concat((0, _htmlescape.default)(__NEXT_DATA__), "\n          module={}\n          __NEXT_LOADED_PAGES__ = []\n\n          __NEXT_REGISTER_PAGE = function (route, fn) {\n            __NEXT_LOADED_PAGES__.push({ route: route, fn: fn })\n          }").concat(page === '_error' ? "\n\n          __NEXT_REGISTER_PAGE(".concat((0, _htmlescape.default)(pathname), ", function() {\n            var error = new Error('Page does not exist: ").concat((0, _htmlescape.default)(pathname), "')\n            error.statusCode = 404\n\n            return { error: error }\n          })") : '', "\n        ")
        }
      }), page !== '/_error' && _react.default.createElement("script", {
        async: true,
        id: "__NEXT_PAGE__".concat(pathname),
        src: "".concat(assetPrefix, "/_next/static/").concat(buildId, "/pages").concat(pagePathname),
        nonce: this.props.nonce
      }), _react.default.createElement("script", {
        async: true,
        id: "__NEXT_PAGE__/_app",
        src: "".concat(assetPrefix, "/_next/static/").concat(buildId, "/pages/_app.js"),
        nonce: this.props.nonce
      }), _react.default.createElement("script", {
        async: true,
        id: "__NEXT_PAGE__/_error",
        src: "".concat(assetPrefix, "/_next/static/").concat(buildId, "/pages/_error.js"),
        nonce: this.props.nonce
      }), staticMarkup ? null : this.getDynamicChunks(), staticMarkup ? null : this.getScripts());
    }
  }]);
  return NextScript;
}(_react.Component);

exports.NextScript = NextScript;
Object.defineProperty(NextScript, "propTypes", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: {
    nonce: _propTypes.default.string
  }
});
Object.defineProperty(NextScript, "contextTypes", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: {
    _documentProps: _propTypes.default.any
  }
});

function getPagePathname(pathname) {
  if (pathname === '/') {
    return '/index.js';
  }

  return "".concat(pathname, ".js");
}